# This "image" is used by the runner
image: docker:latest
services:
  # Inside the runner , "docker in docker" runs as a service,
  #   so docker commands can find the docker daemon and do their thing.
  - docker:dind

stages:
  - build
  - deploy

variables:
  CONTAINER_IMAGE: eu.gcr.io/noted-computing-271923/staticwebsite

build:
  stage: build
  script:
    # - echo $GCLOUD_CREDENTIALS > ${HOME}/gcloud-service-key.json
    # - gcloud auth activate-service-account --key-file=${HOME}/gcloud-service-key.json
    # - gcloud auth configure-docker --quiet
    - echo ${GCLOUD_CREDENTIALS} | docker login -u _json_key --password-stdin https://eu.gcr.io
    - docker build -t ${CONTAINER_IMAGE}:${CI_COMMIT_SHORT_SHA}  .
    - docker push ${CONTAINER_IMAGE}:${CI_COMMIT_SHORT_SHA}

deploy:
  image: google/cloud-sdk
  stage: deploy
  script:
    - echo $GCLOUD_CREDENTIALS > ${HOME}/gcloud-service-key.json
    - gcloud auth activate-service-account --key-file=${HOME}/gcloud-service-key.json
    - gcloud container clusters get-credentials firstcluster --zone europe-west1-b --project noted-computing-271923
    - sed  s/CI_COMMIT_SHORT_SHA/$CI_COMMIT_SHORT_SHA/ deployment.yaml.template > deployment.yaml
    - kubectl apply -f deployment.yaml
